
/*
 * @(#)SharedDataDebugFlags.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

/**
 * Shared Data debug flags interface.
 *
 * @version     0.94 7 April 1997
 * @author      Rich Burridge
 */

interface SharedDataDebugFlags {

    static final boolean Channel_Debug                = false;
    static final boolean ChannelEvent_Debug           = false;
    static final boolean ClientEvent_Debug            = false;
    static final boolean Data_Debug                   = false;
    static final boolean Manageable_Debug             = false;
    static final boolean Naming_Debug                 = false;
    static final boolean Session_Debug                = false;
    static final boolean SessionEvent_Debug           = false;
    static final boolean SessionFactory_Debug         = false;
    static final boolean SharedDataEvent_Debug        = false;
    static final boolean SharedDataException_Debug    = false;
    static final boolean SharedDataObject_Debug       = false;
    static final boolean Token_Debug                  = false;
    static final boolean TokenEvent_Debug             = false;
    static final boolean URLString_Debug              = false;
}
