// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: SampleArc.java
// Classes: SampleArc
// Original Author: ics125b spring 1996
// $Id: SampleArc.java,v 1.6 1997/03/17 23:32:40 jrobbins Exp $

package uci.graphedit.demo;

import uci.graphedit.*;

/** A sample NetArc subclass for use in the Example application. There
 * are no real details here yet. If I was to expand this Example more
 * the arc could have its own attributes, e.g. bandwidth... and it
 * could have its own subclasses of ArcPerspective to make it look a
 * certain way. */

public class SampleArc extends NetArc {
  /** Construct a new SampleArc. */
  public SampleArc() { } /* needs-more-work */

  public ArcPerspective makePerspective(Layer lay) {
    return new ArcPerzLine();
  }

} /* end class SampleArc */
