// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: FunctorIdentity.java
// Classes: FunctorIdentity
// Original Author: jrobbins@ics.uci.edu
// $Id: FunctorIdentity.java,v 1.2 1997/06/10 23:31:25 jrobbins Exp $

package uci.util;

import java.util.*;

/** A useful implementation of interface Functor that simply returns
 *  the same object that was passed to it.  Use this class when you
 *  want to use a method that takes a Functor, but you do not actually
 *  want to apply any function. */

public class FunctorIdentity implements Functor {
  public Object apply(Object x) { return x; }
} /* end class FunctorIdentity */
