
package webflow.frontend;

import java.lang.*;
import java.util.*;
import uci.graphedit.*;

/** 
*
* ActionQuit
*  |
*  +----------------+
*                   |
*                   ActionWebFlowQuit
*/
public class 
ActionWebFlowQuit extends ActionQuit 
                  implements UserInterfaceDebug
{

  /** Editor */
  private WebEditor Wed = null;

  /** 
  * Constructs a new Action with the given:
  */
  public 
  ActionWebFlowQuit(WebEditor _father) 
  { Wed = _father; }

  /** 
  * Executes the action 
  */
  public void 
  doIt(java.awt.Event e)
  {

    if(DEBUG==true)
       System.out.println("in ActionWebFlowQuit.doIt() ");

    if(Wed!=null) Wed.EndSession();

    /** calls the doIt() method of the supper class */
    super.doIt(e);  

  }// end of doIt()

  /**
  * Overwrite 
  */ 
  public String 
  toString() 
  { return new String("ActionWebFlowQuit"); }

  /**
  * Overwrite
  */
  public String
  name() 
  { return toString(); }

}// end class ActionWebFlowQuit 



