
package webflow.frontend;

import java.awt.*;
import java.util.*;
import uci.graphedit.*;
import webflow.frontend.WFtree.*;

/** 
*
* @date Novermber 2, 1997 (Updated November 2, 1997)
* @author H. Timucin Ozdemir
*
*/
public class 
PaletteRefreshButton extends PaletteFig 
{

  ModuleTree mTree;

  PaletteScrollTreeView myViewer;

  public
  PaletteRefreshButton(ModuleTree mt, PaletteScrollTreeView palette)
  {
     mTree =  mt;
     myViewer = palette;

  }// end of CONSTRUCTOR

  /** 
  * Define a button to make for the Example application 
  */
  public Vector 
  defineButtons() 
  {
      Vector v = new Vector();
      Action refresh = new ActionRefreshModuleTree(mTree,myViewer);
      v.addElement(new ActiveButton("Refresh Modules", refresh));

      return v;

  }// end of defineButtons()

} /* end class PaletteRefreshButton */






