package webflow.frontend;


import java.awt.*;
import java.io.*;
import uci.graphedit.*;

/** An example subclass of NetNode for use in the Example application.
*
* @see Example 
*/
public class 
Web4 extends WebNode 
{
	int numports;
  /** 
  * Initialize a new WebNode from the given default node and
  * application specific model. <p>
  */
  public void 
  initialize(NetNode deft, Object model) 
  {
     /***********************************************************/
     /** updates the module info of this node                   */
     /** ActionCreateWebNode sets the ModuleTree.currentItem    */
     /** and then calls the doIt() method of ActionCreateNode   */
     /** in this method control comes back initialize() method  */
     /** of the NetNode object so that we can update the module */
     /** info of our WebNode object.                            */
     /***********************************************************/
     setModuleTreeItem(ModuleTree.currentItem);
	numPorts=4;
	numports=4;
     portList = new WebPort[numports];
     for(int i=0;i<numports;i++)
	     portList[i] = new WebPort(this, "img");

  }// end of initialize()
 

  /**
  * Overwrite
  */
  public Perspective 
  makePerspective(Layer lay) 
  {
	int i=0;
	Fig[] obj;
	int CCol[];
	CCol = new int[numports];
	CCol[0]=1;
CCol[1]=2;
CCol[2]=3;
CCol[3]=3;

/*
	 should be replaced by the foll piece of code if the number of ports are 3 and the values passed to the perl program are val=3+val=1+val=2CCol[0]=1;
CCol[1]=2;
CCol[2]=3;
CCol[3]=3;

	CCol[0]=3;
	CCol[1]=1;
	CCol[2]=2;
*/
     /** A Big Circle which includes everything */
//      Fig obj0 = new FigCircle(-20, -20,(numports*15)+20,(numports*15)+20, 
          //                     Color.black, new Color(0,255,255));
	obj = new Fig[numports+2];

      obj[0] = new FigRect(-30, -30, -30+(numports*15), 20, Color.lightGray,null);
     obj[1]=	new FigRect(-30, -30, (numports*15), 20, Color.red,Color.black);
      FigList temp_list = new FigList();
	//temp_list.addFig(obj0);
      temp_list.addFig(obj[0]);
 temp_list.addFig(obj[1]);	
      for(i=0;i<numports;i++){
	switch(CCol[i])
	{
		case 1:
	 obj[i+2] = new FigCircle( -30+(i*15), -30, 15,15, Color.black,Color.red);
	break;
		case 2:
	obj[i+2] = new FigCircle( -30+(i*15), -30, 15,15, Color.black,Color.green);
	break;	
		case 3:
		obj[i+2] = new FigCircle( -30+(i*15), -30, 15,15, Color.black,Color.blue);
	break;
	}
  	 temp_list.addFig(obj[i+2]);
	}
	System.out.println("Going for PORT ID");
      WebPerspective pers1 = new WebPerspective(this, temp_list);
      for(i=0;i<numports;i++){	
		System.out.println("IN PORT ID");
	      pers1.addPort(portList[i], obj[i+2],1);
	      System.out.println("ID = "+((WebPort)portList[i]).getID());
	}

      return pers1;

   }// end of makePerspective()


}// end class WebNode3 
