package webflow.modules.demo.HPF;

import webflow.frontend.*;
import webflow.modules.demo.SciVis.*;
import webflow.backend.*;
import webflow.modules.demo.image.*;
import java.net.*;
import java.io.*;

public class ConnectFilter  implements Module{
	
public static final int    T_INT         =  551 ;
public static final int    T_FLOAT       =  552;
public static final int    T_DOUBLE      =  553;
public static final int    T_CHAR        =  554;
public static final int    T_BOOL        =  555;
public static final int    T_STRING      =  556;
public static final int    T_ENUM        =  557;
public static final int    T_SUBRANGE    =  558;
public static final int    T_LIST        =  559;
public static final int    T_ARRAY       =  560;
public static final int    T_RECORD      =  561;
public static final int    T_LONG        =  587;
public static final int    T_SHORT       =  588;
public static final int    T_BYTE        =  589;

	ServerSocket listener;
	Socket aSocket;
	String hostName;
 	int portNumber;
	DataPort dataport;
        PlotPort SciVisport;
	recv_module recmod;
	DataInputStream dis;
	DataOutputStream dos;
        DataInputStream filtis;
	Object data;
        SciVisDataObj SciData;
  public double bbs[];
	String winName = null;					
        Socket FiltConfSocket;
        
	public MetaModule initialize(){
		MetaModule mm  = new MetaModule("mm");
       		dataport= new DataPort();
		SciVisport = new PlotPort();
       		mm.putPortID(SciVisport.getPortID());
		mm.putPortID(dataport.getPortID());
		
		 winName = new String("Voyayer");		
			return(mm);
		
	}


	public void run(){
	  try{
	  listener = new ServerSocket(0);
          System.out.println("Addr = "+InetAddress.getLocalHost().getHostName());
	  hostName=InetAddress.getLocalHost().getHostName();
	  portNumber=listener.getLocalPort();	
		String num = Integer.toString(portNumber,10);
	System.out.println("PORT Num = "+num);
	  SockData sk= new SockData(hostName,num);
	 System.out.println("host Name = "+hostName);
	  dataport.send(sk);
	System.out.println("Sent host name");
	  aSocket=listener.accept();
	System.out.println("accepted conn");
	  dis = new DataInputStream (aSocket.getInputStream());
	  dos = new DataOutputStream(aSocket.getOutputStream());
           FiltConfSocket = SciVisport.getSocket();	
          filtis  = new DataInputStream(FiltConfSocket.getInputStream());
	  recmod = new recv_module(dos,dis,true);
	  System.out.println("Got socket conn");
	  int numdat=0;
		  bbs= new double[4];
	 while(true){
	       SciData= new SciVisDataObj(recmod);
		System.out.println("GOing"+aSocket+numdat);
		// recv_registrated_data(recmod);
		SciData.read();
for(int i=0;i<SciData.dims[0];i++)
            System.out.println("DIms in ID " + SciData.dims[0] +" "+SciData.xval[i]+" " +SciData.xval+" "+SciData.db1[i]+ " "+ i+ " "+SciData.xval+" "+SciData.db1.length);
        		SciVisport.send21(SciData.dims[0],SciData.xval,SciData.db1);
		//	    	SciData.write(new BufferedOutputStream(SciVisport.getOutputStream()),new DataInputStream(SciVisport.getInputStream()));
		numdat++;
               confirm(0);
	}
		
	    }
	  catch(IOException e){
	    System.out.println(e);
	}
	}
 void confirm(int flag){
    int readflag ;
  try{
  do
      { 
      
       readflag = filtis.readInt();


      } while(readflag!=flag);
 }
catch(IOException e){
System.out.println(e);
}
 }	
	
	public void send(){
		System.out.println("Sending Data to Scivis");
			System.out.println("Sent Data to Scivis");			
	}

	public void destroy(){
		System.out.println("Entering Destroy");
	    		try{
			aSocket.close();		
		}catch(IOException e){System.out.println(e);}		
		dataport.destroyPort();
		SciVisport.destroyPort();

		}

  public Object  recv_registrated_data(recv_module rlib) throws IOException
  {
    Object buffer=null;
    int []dims = null;

    // receive tag
    float fval ;
        
    int tag = rlib.recv_int();
	System.out.println("tag = " + tag);
    StringBuffer varName=rlib.recv_String();
    System.out.println("varName = " + varName);
    int type  = rlib.recv_int();
   System.out.println("type = " + type);	
   int ndims = rlib.recv_int();
   System.out.println("ndims = " + ndims);
    int nelems = rlib.recv_int();
System.out.println("nelems = " + nelems);
    if (ndims > 0){
	System.out.println("DIM " + ndims);
      dims = new int[ndims];
      rlib.recv_1Dint_array(dims);
    }
    System.out.println("RECEIVED  "+tag+" "+varName+" "+type+" "+ndims+" "+
               nelems+" ");
    switch(type){
    case T_INT:
      switch(ndims){
        case 0:
          int num = rlib.recv_int();
          buffer = new Integer(num);
          break;
        case 1:
          buffer = new int[dims[0]];
          rlib.recv_1Dint_array((int[])buffer);
          break;
        case 2:  
          buffer = new int[dims[0]][dims[1]];
          rlib.recv_2Dint_array((int[][])buffer);
          break;
        case 3:
          buffer = new int[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dint_array((int[][][])buffer);
          break;
      }
      break;
      case T_CHAR:
      switch(ndims){
        case 0:
          char num = rlib.recv_char();
          buffer = new Character(num);
          break;
        case 1:
          buffer = new char[dims[0]];
          rlib.recv_1Dchar_array((char[])buffer);
          break;
        case 2:  
          buffer = new char[dims[0]][dims[1]];
          rlib.recv_2Dchar_array((char[][])buffer);
          break;
        case 3:
          buffer = new char[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dchar_array((char[][][])buffer);
          break;
      }
      break;
      case T_FLOAT:
      switch(ndims){
        case 0:
          float num = rlib.recv_float();
          buffer = new Float(num);
          break;
        case 1:
          buffer = new float[dims[0]];
          rlib.recv_1Dfloat_array((float[])buffer);
          break;
        case 2:  
          buffer = new float[dims[0]][dims[1]];
          rlib.recv_2Dfloat_array((float[][])buffer);
          break;
        case 3:
          buffer = new float[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dfloat_array((float[][][])buffer);
          break;
      }
      break;
      case T_LONG:
      switch(ndims){
        case 0:
          long num = rlib.recv_long();
          buffer = new Long(num);
          break;
        case 1:
          buffer = new long[dims[0]];
          rlib.recv_1Dlong_array((long[])buffer);
          break;
        case 2:  
          buffer = new long[dims[0]][dims[1]];
          rlib.recv_2Dlong_array((long[][])buffer);
          break;
        case 3:
          buffer = new long[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dlong_array((long[][][])buffer);
          break;
      }
      break;
      case T_DOUBLE:
      switch(ndims){
        case 0:
          double num = rlib.recv_double();
          buffer = new Double(num);
          break;
        case 1:
          buffer = new double[dims[0]];
          rlib.recv_1Ddouble_array((double[])buffer);
          break;
        case 2:  
          buffer = new double[dims[0]][dims[1]];
          rlib.recv_2Ddouble_array((double[][])buffer);
          break;
        case 3:
          buffer = new double[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Ddouble_array((double[][][])buffer);
          break;
      }
      break;
      case T_BOOL:
      switch(ndims){
        case 0:
          boolean num = rlib.recv_boolean();
          buffer = new Boolean(num);
          break;
        case 1:
          buffer = new boolean[dims[0]];
          rlib.recv_1Dboolean_array((boolean[])buffer);
          break;
        case 2:  
          buffer = new boolean[dims[0]][dims[1]];
          rlib.recv_2Dboolean_array((boolean[][])buffer);
          break;
        case 3:
          buffer = new boolean[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dboolean_array((boolean[][][])buffer);
          break;
      }
      break;
      case T_BYTE:
      switch(ndims){
        case 0:
          byte num = rlib.recv_byte();
          buffer = new Byte(num);
          break;
        case 1:
          buffer = new byte[dims[0]];
          rlib.recv_1Dbyte_array((byte[])buffer);
          break;
        case 2:  
          buffer = new byte[dims[0]][dims[1]];
          rlib.recv_2Dbyte_array((byte[][])buffer);
          break;
        case 3:
          buffer = new byte[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dbyte_array((byte[][][])buffer);
          break;
      }
      break;
      case T_SHORT:
      switch(ndims){
        case 0:
          short num = rlib.recv_short();
          buffer = new Short(num);
          break;
        case 1:
          buffer = new short[dims[0]];
          rlib.recv_1Dshort_array((short[])buffer);
          break;
        case 2:  
          buffer = new short[dims[0]][dims[1]];
          rlib.recv_2Dshort_array((short[][])buffer);
          break;
        case 3:
          buffer = new short[dims[0]][dims[1]][dims[2]];
          rlib.recv_3Dshort_array((short[][][])buffer);
          break;
      }
      break;
    }

    return buffer;
    
  }
	
	public void stop(){}

	public static void main(String[] args){
		Filter emb = new Filter();
			emb.initialize();
			emb.destroy();
		}		

}	
	


