package webflow.modules.demo.HPF;

import webflow.frontend.*;
import webflow.backend.*;
import webflow.modules.demo.image.*;
import java.net.*;
import java.io.*;

public class HPFsc97example1  implements Module{
  ImgPort imgport,imgport1,imgport2;//impgport3,imgport4;
	ServerSocket listener;
	Socket aSocket;
	String hostName;
 	int portNumber;
	Process p;
        Runtime r;
	DataPort dataport[];
	connection Conn;	
	send_module send_mod;
	recv_module recmod;
	DataInputStream dis;
	String exeName;
	int NumActionPts;
	int hpfPort;
	int KillHPF ; // flag for killing HPF
	int ContrHPF;
	String conffile;

	public MetaModule initialize(){
		MetaModule mm  = new MetaModule("HPF Module");
	
		try
		{
		URL conf =new URL("http://osprey2.npac.syr.edu:3333/VPL-html/example1.config");
		conffile= conf.getFile();
		dis = new DataInputStream(conf.openStream());
		exeName= dis.readLine();			
		String val = dis.readLine();
		System.out.println("VALLLL = "+val);
		hpfPort= Integer.parseInt(val);	
		System.out.println("HELLLLLOOOO Port num = "+hpfPort);

		NumActionPts = 2;
	dataport= new DataPort[NumActionPts];
		for(int i=0;i<NumActionPts;i++){
		   dataport[i]= new DataPort();
		  mm.putPortID(dataport[i].getPortID());
		}
		}
		catch(MalformedURLException e)	{
		System.out.println(e);
		}
		catch(IOException e ){
	    System.out.println(e);
		  }
		return(mm);
		
	}


	public void run(){
	SockData sData[];
	sData= new SockData[3];
	int i=0;
	try{
//	r=  Runtime.getRuntime();
	//p=r.exec("java ConnectSock");

	for( i=0;i<NumActionPts;i++)
	{
		sData[i]= (SockData)dataport[i].receive();
		System.out.println("HOST NAME = "+ sData[i].hostname);
		System.out.println("PORT NUM = "+ sData[i].PortNum);
	}
	boolean bool=true;
	 boolean done = false;
     while(!done)
	     {
        try {
	System.out.println("HPF PORT = " + hpfPort);
	Conn = new connection("osprey2.npac.syr.edu",hpfPort,true);	
 done = true;
        }
        catch (IOException e) {
          System.out.println(e);
          done = false;
        }
     }

	System.out.println("Got conn");
	send_mod= new send_module(Conn);
	recmod = new recv_module(Conn);
	System.out.println("Going for conn");
	send_mod.send_int(41);
	System.out.println("Sent int");
//	send_mod.send_String(conffile);
	System.out.println("sent config file");
	for(i=0;i<NumActionPts;i++)
	{
		String hostn = sData[i].hostname;
		String portn= sData[i].PortNum;
		System.out.println("DATA = "+hostn+portn);
		send_mod.send_String(hostn);
		send_mod.send_String(portn);	
	}
	send_mod.send_int(16);
	int cont = recmod.recv_int();
	System.out.println("CONT "+cont);
	String scont = recmod.recv_String().toString();
	System.out.println("SCON" +scont);
	
	System.out.println("EVERYTHING GONE ");
	/*  while(true)
	{
		System.out.println("Waiting for signal");
		ContrHPF=recmod.recv_int();// waiting for 1
		System.out.println("Recieved signal " + ContrHPF);
		KillHPF=0;//cannot kill
		System.out.println("Waiting for signal");
		ContrHPF=recmod.recv_int(); //waiting for 0		
      		System.out.println("Recieved signal " + ContrHPF);
		KillHPF=1; // Can Kill 
		send_mod.send_int(10); // Continue
		
	}*/
	
	}
/*	catch(MalformedURLException e)	{
	System.out.println(e);
	}
	catch(ConnectException e)
	{
		System.out.println(e);
	}*/
	catch(EOFException e ){
	   System.out.println("Exceptionnnn eof");	
	    System.out.println(e);
	  }
	catch(IOException e ){
	   System.out.println("Exceptionnnn IO");	
	    System.out.println(e);
	  }
	

	}
	public void send(){
/*			try{
				 DataOutputStream dos= new DataOutputStream(aSocket.getOutputStream());
				dos.writeInt(imgdat.width);
				dos.writeInt(imgdat.height);
				dos.write(imgdat.pixels,0,imgdat.width*imgdat.height*4);
			}catch(IOException e){};*/
	}

	public void destroy(){
		System.out.println("Status = " +KillHPF);
		try{
		URL killjob = new URL("http://osprey2.npac.syr.edu:3333/cgi-bin/kill.pl?demo_");
		Conn.close_connection();	
		}	
		catch(MalformedURLException e)
		{
			System.out.println(e);
		}
		catch(IOException e ){
		  System.out.println(e);
		}	
		for(int i=0;i<NumActionPts;i++){
			dataport[i].destroyPort();
		}
		}
	
	public void stop(){}

	public static void main(String[] args){
		Filter emb = new Filter();
			emb.initialize();
			emb.destroy();
		}		

}	
	
