package webflow.modules.demo.image;

import webflow.backend.*;
import webflow.frontend.*;
import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;

public class BWFilterDispl  implements Module{
	
	Image image;
	ImgData imgdat;
	ImgPort imgport,imgport1;
	ServerSocket listener;
	Socket aSocket;
	String hostName;
 	int portNumber;
 	negFilter emb1;
        DataInputStream dis;
	DataOutputStream dos;
	
	public MetaModule initialize(){
		imgdat=null;
		MetaModule mm  = new MetaModule("mm");
		emb1 = new negFilter();
		imgport1= new ImgPort();
		mm.putPortID(imgport1.getPortID());
		imgport=new ImgPort();
		mm.putPortID(imgport.getPortID());
try{
		InetAddress local = java.net.InetAddress.getLocalHost();
		hostName = local.getHostName();
		// open new server socket
		listener = new ServerSocket(0);
		portNumber = listener.getLocalPort();
		}catch(UnknownHostException e){System.out.println(e);}
		 catch(IOException e){System.out.println(e);}
	// Html Code to Display Applet, Add port number of Server on which SessionManagerServlet is present
String JeevPortNum=new String("9001/filters");
	String htmlString=new String("<P><APPLET CODEBASE=\"http://"+hostName+":"+JeevPortNum+"\""+"CODE = \"webflow.modules.demo.image.BWFilterApplet.class\"  WIDTH=600 HEIGHT=1000>\n<PARAM Name=Host");
	htmlString+=" VALUE=";
	htmlString+=hostName;
	htmlString+=">\n<PARAM NAME = portnum VALUE = ";
	htmlString+=String.valueOf(portNumber);
	htmlString+=">\n</APPLET>\n</P>\n";
	
	System.out.println(htmlString);
	mm.setHTML(htmlString);
		return(mm);
		
	}


	public void run(){


		while(true)
		{
		try{
			aSocket=listener.accept();
                       
			dos= new DataOutputStream(aSocket.getOutputStream());
			dis= new DataInputStream(aSocket.getInputStream());
			} catch(IOException e) {System.out.println(e);}
	
		imgdat=(ImgData)imgport.receive();
		 if(imgdat!=null){		
			int w = imgdat.width;
			int h = imgdat.height;
			int[] pixels = new int[w*h];
		
			for(int i=0;i<(w*h);i++)
				{
int a=(int)(imgdat.pixels[4*i]);
int r= (int)(imgdat.pixels[(4*i)+1]);
int g= (int)(imgdat.pixels[(4*i)+2]);
int b= (int)(imgdat.pixels[(4*i)+3]);
pixels[i]=(((a<<24)&0xff000000 )|((r<<16)&0x00ff0000 )|((g<<8)&0x0000ff00 )|(b &0x000000ff ));
				} 
				
			System.out.println(pixels[5]);
			trans(pixels);
			}		
			}
		}

	public  void trans(int[] pixels)  	{
		int w = imgdat.width;
		int h = imgdat.height;
		int[] pixelsi = pixels;
       		pixels=emb1.filter(pixels,w,h);
                  
		for(int i=0;i<(w*h);i++)
		for( i=0;i<(w*h);i++)
		{
			imgdat.pixels[4*i]=(byte) ((pixels[i]>>24)& 0xff);
	imgdat.pixels[(4*i)+1]=(byte) ((pixels[i]>>16) & 0xff);
	imgdat.pixels[(4*i)+2]=(byte) ((pixels[i]>>8) & 0xff);
	imgdat.pixels[(4*i)+3]=(byte) (pixels[i] & 0xff);
			
		}	
		send();
		imgport1.send(imgdat);
	}
	
	public void send(){
			try{
				confirm(1);
				dos.writeInt(imgdat.width);
				dos.writeInt(imgdat.height);
				dos.write(imgdat.pixels,0,imgdat.width*imgdat.height*4);
			}catch(IOException e){};
	}

	public void destroy(){
                 confirm(0);
try{
   aSocket.close();
   }catch(IOException e){System.out.println(e);};
		imgport.destroyPort();
                imgport1.destroyPort();
		}
	
 void confirm(int flag){
    try{
    dos.writeInt(flag);
    }catch(IOException e){System.out.println(e);}
 }
	public void stop(){}

	public static void main(String[] args){
		Filter emb = new Filter();
			emb.initialize();
			emb.destroy();
		}		

}	
	

