package webflow.modules.demo.image;

import webflow.frontend.*;
import webflow.backend.*;
import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;

public class Negative  implements Module{
	
  Image image;
  ImgData imgdat;
  ImgPort imgport,imgport1;
  ServerSocket listener;
  Socket aSocket;
  String hostName;
  int portNumber;
  bwFilter neg;
  
  
  public MetaModule initialize(){
    imgdat=null;
    MetaModule mm  = new MetaModule("mm");
    neg = new bwFilter(1);
    imgport1= new ImgPort();
    mm.putPortID(imgport1.getPortID());
    imgport=new ImgPort();
    mm.putPortID(imgport.getPortID());
    return(mm);
    
  }
  
  
  public void run(){
    
    while(true)
      {
	
	imgdat=(ImgData)imgport.receive();
	if(imgdat!=null){		
	  int w = imgdat.width;
	  int h = imgdat.height;
	  int[] pixels = new int[w*h];
	  
	  for(int i=0;i<(w*h);i++)
	    {
	      int a=(int)(imgdat.pixels[4*i]);
	      int r= (int)(imgdat.pixels[(4*i)+1]);
	      int g= (int)(imgdat.pixels[(4*i)+2]);
	      int b= (int)(imgdat.pixels[(4*i)+3]);
	      pixels[i]=(((a<<24)&0xff000000 )|((r<<16)&0x00ff0000 )|((g<<8)&0x0000ff00 )|(b &0x000000ff ));
	      
	    }
	  System.out.println(pixels[5]);
	  trans(pixels);
	}		
      }
  }
  //Applies Filter on pixels
  public  void trans(int[] pixels)  	{
    int w = imgdat.width;
    int h = imgdat.height;
    int[] pixelsi = pixels;
    pixels = neg.filter(pixels,w,h);
    
    for(int i=0;i<(w*h);i++)
      for( i=0;i<(w*h);i++)
	{
	  imgdat.pixels[4*i]=(byte) ((pixels[i]>>24)& 0xff);
	  imgdat.pixels[(4*i)+1]=(byte) ((pixels[i]>>16) & 0xff);
	  imgdat.pixels[(4*i)+2]=(byte) ((pixels[i]>>8) & 0xff);
	  imgdat.pixels[(4*i)+3]=(byte) (pixels[i] & 0xff);	
	  
	}	
    imgport1.send(imgdat);
  }
  
  public void send(){
    try{
      DataOutputStream dos= new DataOutputStream(aSocket.getOutputStream());
      dos.writeInt(imgdat.width);
      dos.writeInt(imgdat.height);
      dos.write(imgdat.pixels,0,imgdat.width*imgdat.height*4);
    }catch(IOException e){};
  }
  
  public void destroy(){
    imgport.destroyPort();
    imgport1.destroyPort();
  }
  
  public void stop(){}
  
  
  
}	



