package webflow.modules.demo.io;

import java.awt.image.*;
import java.lang.*;
import gjt.filter.*;
import java.net.*;
import java.io.*;
import webflow.frontend.*;
import webflow.backend.*;
/* 
 * This module transmits the image data which it receives from the viewer
 * module
 */

public class OutputModule implements Module {
 //Add port number of Server on which SessionManagerServlet is present
String JeevPortNum=new String("9080/filters");
 	ImgPort imgport;
	ImgData imgdat;	
	ServerSocket listener;
	Socket aSocket;
	String hostName;
 	int portNumber;
	DataInputStream dis;
	DataOutputStream dos;
        Diagnostic diag;
	
    public MetaModule initialize() {
        // Load the image.
	MetaModule mm = new MetaModule("mm");
	int i;
        diag = new Diagnostic("outModule.diag");
	imgport=new ImgPort();
        diag.activate(true);
        diag.write("diagnostic activated");
	mm.putPortID(imgport.getPortID());
	try{
		InetAddress local = java.net.InetAddress.getLocalHost();
		hostName = local.getHostName();
		// open new server socket
		listener = new ServerSocket(0);
		portNumber = listener.getLocalPort();
                diag.write("listener activated");
		}catch(UnknownHostException e){System.out.println(e);}
		 catch(IOException e){System.out.println(e);}
	// Html Code to Display Applet,
//String JeevPortNum=new String("8000"); 
	String htmlString=new String("CODE = \"webflow.modules.demo.io.OutputApplet.class\"  WIDTH=300 HEIGHT=300>\n<PARAM Name=Host");
	htmlString+=" VALUE=";
	htmlString+=hostName;
	htmlString+=">\n<PARAM NAME = portnum VALUE = ";
	htmlString+=String.valueOf(portNumber);
	htmlString+=">\n<PARAM Name=FName VALUE=Output>\n</APPLET>\n</P>\n";
	
	System.out.println(htmlString);
	mm.setHTML(htmlString);
	System.out.println("out");
        diag.write("Done Initializing");
	 return(mm);	
    }

    public ServerSocket getSocket() { return listener; }

	public void run(){
			try{
			aSocket=listener.accept();
                        diag.write("accepted connection");
			dos= new DataOutputStream(aSocket.getOutputStream());
			dis= new DataInputStream(aSocket.getInputStream());
			} catch(IOException e) {System.out.println(e);}
                         diag.write("going for data");
			while(true){
                                 diag.write("waiting for data"); 
				imgdat=(ImgData)imgport.receive();
                                diag.write("accepted data");
				send();
                                diag.write("sent data");
			}
		}	
	
	
	void  send(){
			try{
                        diag.write("Sending data"+ imgdat.width +" "+imgdat.height); confirm(1);
			dos.writeInt(imgdat.width);
			dos.writeInt(imgdat.height);
			dos.write(imgdat.pixels,0,imgdat.width*imgdat.height*4);
 

			} catch(IOException e){System.out.println(e);}	
			diag.write("Sent Image");

		}		


	
  public void destroy(){
 confirm(0); 
try{
   if(aSocket!=null) aSocket.close();
   }catch(IOException e){System.out.println(e);};
   imgport.destroyPort();
   
  }

 void confirm(int flag){
    try{
    if(dos!=null) dos.writeInt(flag);
    }catch(IOException e){System.out.println(e);}
 }
  public void stop(){}

}
