
/*
 * @(#)socketDebugFlags.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData.socket;

/**
 * Shared Data debug flags interface.
 *
 * @version     0.94 7 April 1997
 * @author      Rich Burridge
 */

interface socketDebugFlags {

    static final boolean AuthenticateClient_Debug     = false;

    static final boolean ByteArray_Debug              = false;

    static final boolean ChannelConsumerImpl_Debug    = false;
    static final boolean ChannelProxy_Debug           = false;
    static final boolean ChannelProxyMessage_Debug    = false;
    static final boolean ChannelProxyThread_Debug     = false;
    static final boolean ChannelServer_Debug          = false;

    static final boolean CheckToken_Debug             = false;

    static final boolean ClientImpl_Debug             = false;
    static final boolean ClientMessage_Debug          = false;
    static final boolean ClientProxy_Debug            = false;
    static final boolean ClientProxyMessage_Debug     = false;
    static final boolean ClientProxyThread_Debug      = false;
    static final boolean ClientServer_Debug           = false;
    static final boolean ClientServerMessage_Debug    = false;
    static final boolean ClientServerThread_Debug     = false;
    static final boolean ConsumerMessage_Debug        = false;

    static final boolean ManagerProxyMessage_Debug    = false;
    static final boolean ManagerProxyThread_Debug     = false;

    static final boolean NamingProxy_Debug            = false;

    static final boolean ObserverMessage_Debug        = false;

    static final boolean ProxyByteArray_Debug         = false;

    static final boolean ReceiveClient_Debug          = false;

    static final boolean Registry_Debug               = false;
    static final boolean RegistryServerMessage_Debug  = false;
    static final boolean RegistryServerThread_Debug   = false;

    static final boolean ServerByteArray_Debug        = false;

    static final boolean SessionProxy_Debug           = false;
    static final boolean SessionProxyMessage_Debug    = false;
    static final boolean SessionProxyThread_Debug     = false;
    static final boolean SessionServer_Debug          = false;
    static final boolean SessionServerMessage_Debug   = false;
    static final boolean SessionServerThread_Debug    = false;

    static final boolean SharedByteArrayObserverImpl_Debug = false;

    static final boolean SharedDataManagerImpl_Debug  = false;
    static final boolean SharedDataMessage_Debug      = false;
    static final boolean SharedDataObserverImpl_Debug = false;
    static final boolean SharedDataProxy_Debug        = false;
    static final boolean SharedDataServer_Debug       = false;

    static final boolean SocketServer_Debug           = false;
    static final boolean SocketThread_Debug           = false;

    static final boolean TCPChannelProxyThread_Debug  = false;
    static final boolean TCPSocketServer_Debug        = false;
    static final boolean TCPSocketThread_Debug        = false;

    static final boolean TokenProxy_Debug             = false;
    static final boolean TokenServer_Debug            = false;

    static final boolean UDPChannelProxyThread_Debug  = false;
    static final boolean UDPChannelServerMessage_Debug = false;
    static final boolean UDPChannelServerThread_Debug = false;
    static final boolean UDPPacketParser_Debug        = false;
    static final boolean UDPSocketServer_Debug        = false;
    static final boolean UDPSocketThread_Debug        = false;

    static final boolean socketClient_Debug           = false;
    static final boolean socketSharedDataObject_Debug = false;
    static final boolean socketSession_Debug          = false;
}
