// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: ArcPower.java
// Classes: ArcPower
// Original Author: jrobbins@ics.uci.edu
// $Id: ArcPower.java,v 1.4 1997/06/10 23:40:26 jrobbins Exp $

package uci.graphedit.demo;

import uci.graphedit.*;

/** A sample NetArc subclass for use in the Example application. */

public class ArcPower extends NetArc {

  ////////////////////////////////////////////////////////////////
  // instance variables

  /** Voltage currently on line. */
  protected int _voltage;

  /** Maximum Voltage that this line can handle. */
  protected int _maxVoltage;

  /** Some power cords have a third grounding prong, some don't. */
  protected boolean _hasGroundProng;

  ////////////////////////////////////////////////////////////////
  // constructor

  public ArcPower() { } /* needs-more-work */

  ////////////////////////////////////////////////////////////////
  // NetArc API

  public ArcPerspective makePerspective(Layer lay) {
    return new ArcPerzLine();
  }

} /* end class ArcPower */
