package webflow.modules.demo.image;

/*
    A basic extension of the java.applet.Applet class
 */

import java.awt.*;
import java.applet.*;

public class BrightParam extends Frame implements Runnable{
int percent;
FilterSocketB socket;
String host;
int port;
private Thread runner;
	public BrightParam(String host,int port,String name,String scroll) {
      		//{{INIT_CONTROLS

super(name);
socket=new FilterSocketB(host,port,this);
		setLayout(null);
		addNotify();

percent=0;
		resize(350,120);
		horizontalScrollbar1 = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,0,1,0,100);
		horizontalScrollbar1.reshape(132,36,116,21);
		add(horizontalScrollbar1);
		
		label1 = new java.awt.Label(scroll);
		label1.reshape(24,36,72,21);
		add(label1);
		
show();
start();

		//}}
	}

	public boolean handleEvent(Event event) {
if(event.target==horizontalScrollbar1)
     scroll_event(event);

return true;
	}


  void scroll_event(Event event){
    switch(event.id){
    case Event.SCROLL_ABSOLUTE :
    case Event.SCROLL_LINE_DOWN :
    case Event.SCROLL_LINE_UP:
    case Event.SCROLL_PAGE_DOWN:
    case Event.SCROLL_PAGE_UP :
       percent=((Integer)event.arg).intValue();
      
write_val();
    break;
    }
  }

  void write_val(){
System.out.println("brightness = " +percent);
socket.send(percent);
  }

  public void start(){
    if(runner==null){
runner=new Thread(this);
runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
runner.stop();
runner=null;
    }
socket.stop();
  }

  public void run(){
System.out.println("Inside run");
  }
	//{{DECLARE_CONTROLS
	java.awt.Scrollbar horizontalScrollbar1;
	java.awt.Label label1;

	//}}
}
