/*
    A basic extension of the java.applet.Applet class
 */

package webflow.modules.demo.image;

import java.awt.*;
import java.applet.*;

public class HSBParam extends Frame implements Runnable{
int h;
int s;
int v;
FilterSocket socket;
String host;
int port;
private Thread runner;
	public HSBParam(String host,int port,String name) {
      		//{{INIT_CONTROLS

super(name);
socket=new FilterSocket(host,port,this);
		setLayout(null);
		addNotify();
s=255;
h=255;
v=255;

		resize(426,266);
		horizontalScrollbar1 = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,0,1,0,100);
		horizontalScrollbar1.reshape(132,36,116,21);
		add(horizontalScrollbar1);
		horizontalScrollbar2 = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,0,1,0,100);
		horizontalScrollbar2.reshape(132,84,116,21);
		add(horizontalScrollbar2);
		horizontalScrollbar3 = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,0,1,0,100);
		horizontalScrollbar3.reshape(132,132,116,21);
		add(horizontalScrollbar3);
		label1 = new java.awt.Label("Hue");
		label1.reshape(24,36,72,21);
		add(label1);
		label2 = new java.awt.Label("Saturation");
		label2.reshape(24,84,72,22);
		add(label2);
		label3 = new java.awt.Label("Brightness");
		label3.reshape(24,132,84,24);
		add(label3);
show();
start();

		//}}
	}

	public boolean handleEvent(Event event) {
if(event.target==horizontalScrollbar1)
     scroll_event(1,event);
if(event.target==horizontalScrollbar2)
     scroll_event(2,event);
if(event.target==horizontalScrollbar3)
     scroll_event(3,event);
return true;
	}


  void scroll_event(int id,Event event){
    switch(event.id){
    case Event.SCROLL_ABSOLUTE :
    case Event.SCROLL_LINE_DOWN :
    case Event.SCROLL_LINE_UP:
    case Event.SCROLL_PAGE_DOWN:
    case Event.SCROLL_PAGE_UP :
      switch(id){
      case 1: h=((Integer)event.arg).intValue();
break;
      case 2:s=((Integer)event.arg).intValue();
break;
      case 3:v=((Integer)event.arg).intValue();
break;
      }
write_val();
    break;
    }
  }

  void write_val(){
System.out.println("H="+h+" V =" +v+"S= "+s);
socket.send(h,s,v);
  }

  public void start(){
    if(runner==null){
runner=new Thread(this);
runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
runner.stop();
runner=null;
    }
socket.stop();
  }

  public void run(){
System.out.println("Inside run");
  }
	//{{DECLARE_CONTROLS
	java.awt.Scrollbar horizontalScrollbar1;
	java.awt.Scrollbar horizontalScrollbar2;
	java.awt.Scrollbar horizontalScrollbar3;
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.Label label3;
	//}}
}
