/**********************************************************************************************
* Class plotfiltersp filters 1-D data and sends the data to the Scivis 1-D module            *
**********************************************************************************************/

package webflow.modules.demo.image;

import webflow.frontend.*;
import webflow.backend.*;
import webflow.modules.demo.SciVis.*;
import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;

public class plotfiltersp implements Module{
	Double data_xvalue,data_yvalue;
        Graphics g;
	IntData pdata,pdata1;
        int imgdat1,imgdat;
	PlotPort p1,p3;
	ServerSocket listener;
        ServerSocket sender;
	Socket aSocket;
	String hostName;
 	int portNumber;
	double temp2,temp3;
	
double[] arr=new double[360];
double[] xarr1;   
double[] yarr1;  
double[] xarray;
double[] yarray;

DataOutputStream dos;
DataInputStream dis;
int portNumber1;
boolean bool=false;
int Point,pi=1,inc=0,counter=0;
FilterSocketsp socket;
SciVisPlotPort p2;



//initilialize method of the module which creates the ports
public MetaModule initialize(){
MetaModule mm  = new MetaModule("mm");
p2=new SciVisPlotPort();
mm.putPortID(p2.getPortID());
p1= new PlotPort();
mm.putPortID(p1.getPortID());



 try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
      // open new server socket

      listener = new ServerSocket(0);
      portNumber = listener.getLocalPort(); 
    }
   catch(UnknownHostException e)
    {
       System.out.println(e);
    }
    catch(IOException e)
    {
     System.out.println(e);
     }

// Html Code to Display Applet 

    String htmlString=new String(" CODE = \"webflow.modules.demo.image.PlotAppletsp.class\"  WIDTH=250 HEIGHT=300>\n<PARAM Name=Host");
    htmlString+=" VALUE=";
    htmlString+=hostName;

    htmlString+=">\n<PARAM NAME = portnum VALUE = ";
    htmlString+=String.valueOf(portNumber);
    htmlString+=">\n<PARAM Name=FName VALUE=plotdata ";
    htmlString+=">\n </APPLET>\n</P>\n";
    System.out.println(htmlString);
    mm.setHTML(htmlString);

		return(mm);
		
	}

//stores the values read from the scrollbar into a variable pi
public void setval(int pt)
{

pi=pt;

}

//run method of the module

	public void run(){
	  try{
	System.out.println("accepting socket");
              aSocket=listener.accept();
	System.out.println("getting socket");
              socket=new FilterSocketsp(aSocket,this);
	       dos= new DataOutputStream(aSocket.getOutputStream()); 
	  Socket bSocket = p2.getSocket();
           dis = new DataInputStream(bSocket.getInputStream());
	  } 
	catch(IOException e) 
		{
			System.out.println(e);
		}
		
	for(int k=0;k<1000;k++)    
		
		{
		
		transform();
			}
	}
	
// this method receives the data from the plotdatasp module and filters the data	
public void transform()
{		
		
  		 pdata=(IntData)p1.receive2();	
		int len=pdata.len;
        xarray=new double[len];
        yarray=new double[len];
		
		for(int j=0;j<len;j++)
		{
		 xarray[j]=pdata.xvalue[j];  //receives the x and y values and stores them in an 
		 yarray[j]=pdata.yvalue[j];  //array
		}
		
		while(bool){}
		bool=true;		
		
       		 xarr1=new double[len];
        	 yarr1=new double[len];
		for(int j=0;j<len;j++)

		{
		 if(j%pi==0)	
		{
		 xarr1[j/pi]=xarray[j];    //filters the data depending upon the mod of j and 
		 yarr1[j/pi]=yarray[j];    //value recieved from the scrollbar
		}
               
		else
		{
		xarr1[j]=xarray[j];
		yarr1[j]=yarray[j];
		}

		}
		bool=false;	
		
		int length=len/pi;
		p2.send_1d(length,xarr1,yarr1);   //send the data
		confirm(0);      //waits until the data is received by the scivis module
		
		
	       

}



//destroy method of the module
public void destroy(){
confirm1(1);
socket.stop();
try{
aSocket.close();
}
catch(IOException e) 
{System.out.println(e);
}
		p1.destroyPort();
       		p2.destroyPort();
		
	}

 



// confirm method waits until the data is received by the scivis module	
 void confirm(int flag){
    int readflag ;
  try{
  do
      { 
        readflag = dis.readInt();


      } while(readflag!=flag);
 }
catch(IOException e){
System.out.println(e);
}
}

//confirm1 writes a 1 to the socket to inform the applet to destroy itself
void confirm1(int flag1)
{
 try{

    dos.writeInt(flag1);
    }catch(IOException e){System.out.println("exception"+e);}
 }	
	

public void stop(){}               

}	
	









B
B
B
B
B
B

