/************************************************************************************
* Class plotframe3dsp is the frame which is embedded in the PlotApplet3dsp applet.It *
* opens a socket connection with FilterSocket3dsp, which communicates between the    *
* PlotApplet3dsp and the plotfilter3dsp module					     *
************************************************************************************/
package webflow.modules.demo.image;

import java.awt.*;
import java.applet.*;

public class plotframe3dsp extends Frame implements Runnable
{
 int port;
 int point,num=1;;
 String host;
 FilterSocket3dsp socket;
 private Thread runner;
 TextArea text1,text2;
 Panel p;
 Graphics g;
 Font fo;
  Canvas can;
  CheckboxGroup c;  
 Scrollbar horizontalScrollbar;

 public plotframe3dsp(String host,int port,String name)
 {
 super(name);
 socket=new FilterSocket3dsp(host,port,this);
 setLayout(new GridLayout(4,1));

 resize(500,350);
 Panel foot = new Panel();
 foot.setLayout(new GridLayout(1,3));
  text2=new java.awt.TextArea("MODULE FOR SPATIAL FILTERING");	
 foot.add(text2);
 add("North",foot);
 
 
 Panel body = new Panel();
 body.setLayout(new GridLayout(1,2));
 horizontalScrollbar = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,50,1,0,99);
 horizontalScrollbar.reshape(115,36,250,21);
  body.add(horizontalScrollbar);
  text1=new java.awt.TextArea("VALUE FROM THE SCROLLBAR::");
  text1.appendText(String.valueOf(50));
  body.add(text1);
  add("Center",body);
 Panel head = new Panel();
  head.setLayout(new GridLayout(1,3));
 c = new CheckboxGroup();
 head.add( new Checkbox("XY", c, true));
 head.add( new Checkbox("YZ", c, false));
 head.add( new Checkbox("XZ", c, false)); 
 add("South",head);

 

 
 
   show();
 start();
}


public void paint(Graphics g)
{
 g.drawRect(20,20,60,70);
 g.drawRect(40,40,60,70);
 g.drawLine(20,20,40,40);
 g.drawLine(20,90,40,110);
 g.drawLine(80,20,100,40);
 g.drawLine(80,90,100,110);
}


//sets the value of the scrollbar in the textfield
void set_text(String tex)
{
 text1.replaceText(tex,25,28);
}

public boolean handleEvent(Event event) {
if(event.target==horizontalScrollbar)
    { scroll_event(event);
return true;}
return super.handleEvent(event);
}




public boolean action(Event e,Object o)
{
 if(e.target instanceof Checkbox)
 {
  System.out.println("entered action");
  String current = new String(c.getCurrent().getLabel());
  if(current.equals("XY")) write_val(1,1);
  if(current.equals("YZ")) write_val(1,2);
  if(current.equals("XZ")) write_val(1,3);
  return true;
 }
 return false;
}



void scroll_event(Event event)
{
 switch(event.id)
 {
  case Event.SCROLL_ABSOLUTE:
  case Event.SCROLL_LINE_DOWN:
  case Event.SCROLL_LINE_UP:
  case Event.SCROLL_PAGE_DOWN:
  case Event.SCROLL_PAGE_UP:
  point=((Integer)event.arg).intValue();
   String tex=String.valueOf(point);
  set_text(tex);
  write_val(2,point);
 }
}


//sends the value of the scrollbar to the DataOutputStream 
void write_val(int val,int point)
{
 
 socket.send(val,point);
}             

public void start(){
    if(runner==null){
runner=new Thread(this);
runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
runner.stop();
runner=null;
    }
socket.stop();
  }


 public void run()
{
   	java.awt.Scrollbar horizontalScrollbar;
}

}







