package webflow.modules.demo.util;

import webflow.frontend.*;
import webflow.backend.*;
import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;

public class DisplayModule  implements Module{
	
	Image image;
	ImgData imgdat;
	ImgPort imgport,imgport1;
	ServerSocket listener;
	Socket aSocket;
	String hostName;
 	int portNumber;
        DataInputStream dis;
	DataOutputStream dos;
	
	public MetaModule initialize(){
		imgdat=null;
		MetaModule mm  = new MetaModule("mm");
		imgport1= new ImgPort();
		mm.putPortID(imgport1.getPortID());
		imgport=new ImgPort();
		mm.putPortID(imgport.getPortID());
try{
		InetAddress local = java.net.InetAddress.getLocalHost();
		hostName = local.getHostName();
	 	// open new server socket
		listener = new ServerSocket(0);
		portNumber = listener.getLocalPort();
		}catch(UnknownHostException e){System.out.println(e);}
		 catch(IOException e){System.out.println(e);}
	// Html Code to Display Applet, Add port number of Server on which SessionManagerServlet is present
String JeevPortNum=new String("9001/filters");
	String htmlString=new String("CODE = \"webflow.modules.demo.io.OutputApplet.class\"  WIDTH=600 HEIGHT=1000>\n<PARAM Name=Host");
	htmlString+=" VALUE=";
	htmlString+=hostName;
	htmlString+=">\n<PARAM NAME = portnum VALUE = ";
	htmlString+=String.valueOf(portNumber);
	htmlString+=">\n<PARAM Name=FName VALUE=Display>\n</APPLET>\n</P>\n";
	
	System.out.println(htmlString);
	mm.setHTML(htmlString);
		return(mm);
		
	}


	public void run(){


		while(true)
		{
		try{
			aSocket=listener.accept();
                       
			dos= new DataOutputStream(aSocket.getOutputStream());
			dis= new DataInputStream(aSocket.getInputStream());
			} catch(IOException e) {System.out.println(e);}
	
		imgdat=(ImgData)imgport.receive();
                send();
                 imgport1.send(imgdat);
		}

	}	
	
	public void send(){
			try{
				confirm(1);
				dos.writeInt(imgdat.width);
				dos.writeInt(imgdat.height);
				dos.write(imgdat.pixels,0,imgdat.width*imgdat.height*4);
			}catch(IOException e){};
	}

	public void destroy(){
                 confirm(0);
try{
   aSocket.close();
   }catch(IOException e){System.out.println(e);};
		imgport.destroyPort();
                imgport1.destroyPort();
		}
	
 void confirm(int flag){
    try{
    dos.writeInt(flag);
    }catch(IOException e){System.out.println(e);}
 }
	public void stop(){}

	
}	
	

